import psycopg2

from util import *

log = logging.getLogger("mint.database")

class MintDatabase(object):
    def __init__(self, app, dsn):
        self.app = app
        self.dsn = dsn

    def get_connection(self):
        return psycopg2.connect(self.dsn)

    def check(self):
        log.info("Checking %s", self)

        self.check_connection()

    def init(self):
        log.info("Initializing %s", self)

    def check_connection(self):
        conn = self.get_connection()

        try:
            cursor = conn.cursor()
            cursor.execute("select now()")

            log.debug("Database is talking at '%s'", self.dsn)
        finally:
            conn.close()

    def __repr__(self):
        return self.__class__.__name__
