from update import *
from util import *

log = logging.getLogger("mint.vacuum")

class VacuumThread(MintPeriodicProcessThread):
    def __init__(self, app):
        super(VacuumThread, self).__init__(app, 60 * 60)

    def init(self):
        super(VacuumThread, self).init()

        log.debug("Vacuum interval is %i seconds", self.interval)

    def run(self):
        if self.interval >= 60 * 60:
            time.sleep(0.25 * self.interval)
        else:
            time.sleep(self.interval)
        super(VacuumThread, self).run()

    def process(self):
        log.info("Starting vacuum")

        conn = self.app.database.get_connection()
        conn.set_isolation_level(0)

        try:
            cursor = conn.cursor()

            cursor.execute("vacuum analyze")
        finally:
            conn.close()

        log.info("Finished vacuum")
