from util import *

log = logging.getLogger("rosemary.sqlfilter")

class SqlFilter(object):
    pass

class SqlComparisonFilter(SqlFilter):
    def __init__(self, this, that, operator="="):
        super(SqlComparisonFilter, self).__init__()

        assert isinstance(operator, str)

        self.this = getattr(this, "identifier", this)
        self.that = getattr(that, "identifier", that)
        self.operator = operator

    def emit(self):
        return "%s %s %s" % (self.this, self.operator, self.that)

class SqlValueFilter(SqlComparisonFilter):
    def __init__(self, this, operator="="):
        that = "%%(%s)s" % this.name
        super(SqlValueFilter, self).__init__(this, that, operator)

class SqlExistenceFilter(SqlFilter):
    def __init__(self, subquery, operator="exists"):
        super(SqlExistenceFilter, self).__init__()

        self.subquery = subquery
        self.operator = operator

    def emit(self):
        return "%s (%s)" % (self.operator, self.subquery)

class SqlLikeFilter(SqlValueFilter):
    BEGINS = "B"
    CONTAINS = "C"
    def __init__(self, this, operator="like"):
        super(SqlLikeFilter, self).__init__(this, operator)
